<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['cai:payTrdConfig:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['cai:payTrdConfig:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['cai:payTrdConfig:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="payTrdConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="启用支付宝" align="center" prop="enableStatus" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleOpenStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="启用微信" align="center" prop="enableWxStatus" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableWxStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleOpenWxStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="启用IOS" align="center" prop="enableIos" >
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableIos"
              :active-value="1"
              :inactive-value="0"
              @change="handleOpenIosChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="支付类型" align="center" prop="type" />
      <el-table-column label="轮训比重" align="center" prop="forNum" />
<!--      <el-table-column label="最小金额" align="center" prop="minAmount" />-->
<!--      <el-table-column label="最大金额" align="center" prop="maxAmount" />-->
      <el-table-column label="排序" align="center" prop="sortBy" />
      <el-table-column label="支付名称" align="center" prop="name" />
      <el-table-column label="商户ID" align="center" prop="mchId" />
      <el-table-column label="支付宝ID" align="center" prop="aliProductId" />
      <el-table-column label="微信ID" align="center" prop="wxProductId" />
      <el-table-column label="请求域名" align="center" prop="gatewayUrl" show-overflow-tooltip />
      <el-table-column label="回调域名" align="center" prop="notifyUrl" show-overflow-tooltip  />
      <el-table-column label="秘钥" align="center" prop="sign" show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="120">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['cai:payTrdConfig:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['cai:payTrdConfig:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <pay-trd-config-add-or-update-dialog v-if="payTrdConfigAddOrUpdateVisible" ref="payTrdConfigAddOrUpdate" @refreshDataList="getList" />
  </div>
</template>

<script>
import {
  delPayTrdConfig,
  listPayTrdConfig,
  updateEnableStatusPayTrdConfig,
  updatePayTrdConfig
} from "@/api/cai/payTrdConfig";
import PayTrdConfigAddOrUpdateDialog from "@/views/cai/payTrdConfig/pay-trd-config-add-or-update-dialog.vue";
import {updateAnchor} from "@/api/cai/anchor";

export default {
  name: "PayTrdConfig",
  components: {PayTrdConfigAddOrUpdateDialog},
  data() {
    return {
      payTrdConfigAddOrUpdateVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 四方支付配置表格数据
      payTrdConfigList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询四方支付配置列表 */
    getList() {
      this.loading = true;
      listPayTrdConfig(this.queryParams).then(response => {
        this.payTrdConfigList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.payTrdConfigAddOrUpdateVisible = true
      this.$nextTick(() => {
        this.$refs.payTrdConfigAddOrUpdate.init()
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.payTrdConfigAddOrUpdateVisible = true
      this.$nextTick(() => {
        this.$refs.payTrdConfigAddOrUpdate.init(row.id)
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除四方支付配置编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delPayTrdConfig(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleOpenStatusChange(row){
      let text = row.enableStatus === 0 ? '关闭' : '启用'
      this.$confirm('确认要' + text + '该配置吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateEnableStatusPayTrdConfig({ id: row.id, enableStatus: row.enableStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
        this.getList()
      }).catch(function() {
        row.enableStatus = row.enableStatus === 1 ? 0 : 1
      })
    },
    handleOpenWxStatusChange(row){
      let text = row.enableWxStatus === 0 ? '关闭' : '启用'
      this.$confirm('确认要' + text + '该配置吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updatePayTrdConfig({ id: row.id, enableWxStatus: row.enableWxStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
        this.getList()
      }).catch(function() {
        row.enableWxStatus = row.enableWxStatus === 1 ? 0 : 1
      })
    },
    handleOpenIosChange(row){
      let text = row.enableIos === 0 ? '关闭' : '启用'
      this.$confirm('确认要' + text + '该配置吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updatePayTrdConfig({ id: row.id, enableIos: row.enableIos })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
        this.getList()
      }).catch(function() {
        row.enableIos = row.enableIos === 1 ? 0 : 1
      })
    },
  }
};
</script>
